//+------------------------------------------------------------------+
//| ADX Crossing.mq4 
//| Amir
//+------------------------------------------------------------------+
//20090309fxtsd    mrwobbles  ADX, RSI & ATR strategy 
// http://www.forex-tsd.com/suggestions-trading-systems/18632-adx-rsi-atr-strategy.html

//ara1sigtest rsi1crossOBldn 
//ara2sigtest adxup 
//ara3sigtest rsi1crossOSlup||rsi2crossOSlup

//x rsi1crossOBlup && RSI10>RSI20 &&  RSI20>50 && adxup
//x1 RSI10>RSI_OSlv && RSI10>RSI11 && adxup 
//x2 rsi1cross2up &&  RSI20>50 && adxup




#property  copyright "Author - Amir"
//----
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red
//---- input parameters
extern int  ADXperiod      = 14; //11
extern int  adxDIperiod    = 14; //24
extern bool ADX_levelON    = true;
extern bool DI_levelON     = true;//false//true
extern bool DIrectiON      = true;

  extern int  ADX_level   = 20;

  extern int  DI_level   = 20;
//extern int  DI_level_h = 20;
//extern int  DI_level_l = 10;


extern int RSI1_Period=5;
extern int RSI2_Period=21;//14
extern int RSI_Price=PRICE_CLOSE;

extern int RSI_OBlv=70;
extern int RSI_OSlv=30;

extern bool ARAsig1test =false;//true//falsetrue
extern bool ARAsig2test =false;//falsefalsefalse
extern bool ARAsig3test =false;//falsetrue

extern bool sigXtest  =true;
extern bool sigX1test =false;
extern bool sigX2test =false;


//
extern int CountBars=2500;
extern bool    Sound=true;
extern string  SoundFile   =  "wait.waw";
extern bool    BoxAlert    =  false;
//---- 
double val1[];
double val2[];
double b4plusdi,nowplusdi,b4minusdi,nowminusdi,b4adxmain,nowadxmain;
bool SoundBuy  =False;
bool SoundSell =False;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- indicator line
   IndicatorBuffers(2);
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,108);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,108);
   SetIndexBuffer(0,val1);
   SetIndexBuffer(1,val2);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| AltrTrend_Signal_v2_2                                            |
//+------------------------------------------------------------------+
int start()
  {
  if (CountBars>=Bars) CountBars=Bars;
   SetIndexDrawBegin(0,Bars-CountBars);
   SetIndexDrawBegin(1,Bars-CountBars);
   int i,shift,limit,CountedBars=IndicatorCounted();
   if (CountedBars < 1)
     {
      for(i=0; i<=CountBars; i++) {val1[i]=0.0; val2[i]=0.0;}
     }

   if(CountedBars > 0) CountedBars--;
// //----   
   limit=Bars - CountedBars;
//----
   for(shift=limit; shift>=0; shift--)
   {  


      nowadxmain = iADX(NULL,0,ADXperiod,PRICE_CLOSE,MODE_MAIN,shift);
      b4adxmain  = iADX(NULL,0,ADXperiod,PRICE_CLOSE,MODE_MAIN,shift+1);

      nowplusdi=iADX(NULL,0,adxDIperiod,PRICE_CLOSE,MODE_PLUSDI,shift);
      b4plusdi =iADX(NULL,0,adxDIperiod,PRICE_CLOSE,MODE_PLUSDI,shift+1);
      
      nowminusdi=iADX(NULL,0,adxDIperiod,PRICE_CLOSE,MODE_MINUSDI,shift);
      b4minusdi =iADX(NULL,0,adxDIperiod,PRICE_CLOSE,MODE_MINUSDI,shift+1);

///

      bool adxLvOk = false;
      if (!ADX_levelON || nowadxmain>=ADX_level) adxLvOk = true;
      bool diLvOk  = false;
      if (!DI_levelON  || nowplusdi>DI_level||nowminusdi>DI_level) diLvOk = true;
      
      bool DirUp = false;
      if (!DIrectiON || nowplusdi>b4plusdi)        DirUp = true;
      bool DirDn = false;
      if (!DIrectiON || nowminusdi>b4minusdi)      DirDn = true;


      bool adxup = false;
      if (nowplusdi>nowminusdi  && DirUp  && diLvOk && adxLvOk) adxup=true;
   
      bool adxdn = false;
      if (nowplusdi<nowminusdi  && DirDn  && diLvOk && adxLvOk) adxdn=true;

    
//--- 

      
      
      double RSI10 =  iRSI(NULL,0,RSI1_Period,RSI_Price,shift);
      double RSI11 =  iRSI(NULL,0,RSI1_Period,RSI_Price,shift+1);

      double RSI20 =  iRSI(NULL,0,RSI2_Period,RSI_Price,shift);
      double RSI21 =  iRSI(NULL,0,RSI2_Period,RSI_Price,shift+1);



      bool rsi1crossOSlup = false;
      if(RSI10>RSI_OSlv && RSI11<RSI_OSlv) rsi1crossOSlup =true;
      bool rsi1crossOSldn = false;
      if(RSI10<RSI_OSlv && RSI11>RSI_OSlv) rsi1crossOSldn =true;

      bool rsi1crossOBlup = false;
      if(RSI10>RSI_OBlv && RSI11<RSI_OBlv) rsi1crossOBlup =true;
      bool rsi1crossOBldn = false;
      if(RSI10<RSI_OBlv && RSI11>RSI_OBlv) rsi1crossOBldn =true;
     
     
      bool rsi2crossOSlup = false;
      if(RSI20>RSI_OSlv && RSI21<RSI_OSlv) rsi2crossOSlup =true;

      bool rsi2crossOBldn = false;
      if(RSI20<RSI_OBlv && RSI21>RSI_OBlv) rsi2crossOBldn =true;


//

      bool rsi1cross2up = false;
      if(RSI10>RSI20 && RSI11<RSI21 ) rsi1cross2up =true;

      bool rsi1cross2dn = false;
      if(RSI10<RSI20 && RSI11>RSI21 ) rsi1cross2dn =true;


//---      


//    bool adxup = false; 
//    bool rsi1crossOSlup = false;  bool rsi1crossOSldn = false;
//    bool rsi2crossOSlup           bool rsi2crossOBldn
//    bool rsi1cross2up = false;    rsi1cross2dn
      
       
                                       bool allupchecked=false;
                                       bool alldnchecked=false;
       
       
   if (ARAsig1test &&
       rsi1crossOSlup )//&& adxup  rsi1crossOSlup  && rsi2crossOSlup 
                                                allupchecked=true;

                                          
   if (ARAsig1test &&
       rsi1crossOBldn  ) //&& adxdn rsi1crossOBldn&&|| rsi2crossOBldn 
                                                alldnchecked=true;

///

   if (ARAsig2test &&
        adxup)// rsi1crossOSlup &&|| rsi2crossOSlup RSI20>50
                                                allupchecked=true;

   if (ARAsig2test &&
          adxdn)//&&rsi1crossOBldn|| rsi2crossOSlup RSI20<50

                                                alldnchecked=true;

///

   if (ARAsig3test &&
        rsi1crossOSlup || rsi2crossOSlup  )//&& adxup &&adxupRSI20>50
                                                allupchecked=true;

   if (ARAsig3test &&
          rsi1crossOBldn|| rsi2crossOBldn)// && adxdnadxdn&&p RSI20<50

                                                alldnchecked=true;


//----

   if (sigXtest &&
          rsi1crossOBlup &&  RSI10>RSI20 &&  RSI20>50 && adxup)//
       
                                                 allupchecked=true;

   if (sigXtest &&
         rsi1crossOSldn &&  RSI10<RSI20 &&  RSI20<50 && adxdn)
       
                                                 alldnchecked=true;


   if (sigX1test &&
         RSI10>RSI_OSlv && RSI10>RSI11 && adxup )// rsi1crossOSlup  && rsi2crossOSlup 
       
                                                 allupchecked=true;

   if (sigX1test &&
         RSI10<RSI_OBlv &&  RSI10<RSI11 && adxdn ) // rsi1crossOBldn&&|| rsi2crossOBldn 

                                                 alldnchecked=true;
       
//

   if (sigX2test &&
           rsi1cross2up &&  RSI20>50 && adxup)// rsi1crossOBlup &&
       
                                                 allupchecked=true;

   if (sigX2test &&
           rsi1cross2dn &&  RSI20<50 && adxdn)//rsi1crossOSldn &&
       
                                                 alldnchecked=true;

//---------------


         if (allupchecked)
      
            val1[shift]=Low[shift+1]-iATR(NULL,0,5,i);
         
         
         
         if (alldnchecked)

            val2[shift]=High[shift+1]+iATR(NULL,0,5,i);

   
   
   }

//-- 

   if (val1[0]!=EMPTY_VALUE && val1[0]!=0 && SoundBuy)
     {
      SoundBuy=False;
      if (Sound) PlaySound (SoundFile);
      if (BoxAlert) Alert(Symbol(), " M", Period(),  " syst.sig.UP");
    
     }
   if (!SoundBuy && (val1[0]==EMPTY_VALUE || val1[0]==0)) SoundBuy=True;
   if (val2[0]!=EMPTY_VALUE && val2[0]!=0 && SoundSell)
     {
      SoundSell=False;
      if (Sound) PlaySound (SoundFile);
      if (BoxAlert) Alert(Symbol(), " M", Period(),  " syst.sig.DN");

     }
   if (!SoundSell && (val2[0]==EMPTY_VALUE || val2[0]==0)) SoundSell=True;
   return(0);
  }
//+------------------------------------------------------------------+